//----------------------------------------------------------------------------
#ifndef DcjBtnEdtH
#define DcjBtnEdtH
//----------------------------------------------------------------------------
#include "Dcjdef.h"
#include <vcl\System.hpp>
#include <vcl\Windows.hpp>
#include <vcl\SysUtils.hpp>
#include <vcl\Classes.hpp>
#include <vcl\Graphics.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\ExtCtrls.hpp>
#include <vcl\Dsgnintf.hpp>
#include <Menus.hpp>
#include <Mask.hpp>
#include "DcjMsgDg.h"
//----------------------------------------------------------------------------
// constants
// set up the modal result array
const AnsiString MODAL_RESULT[] = {"mrNone", "mrOk", "mrCancel", "mrAbort",
    "mrRetry", "mrIgnore", "mrYes", "mrNo"};

// enumerations
enum TButtonTemplates {btDefault, btOk, btCancel, btHelp, btYes, btNo,
    btAbort, btRetry, btIgnore};

//----------------------------------------------------------------------------
class TDcjButtonsEditDlg : public TForm
{
__published:
  TButton *cmdOk;
  TButton *cmdCancel;
  TGroupBox *gpButtons;
  TListBox *lstButtons;
  TButton *cmdNew;
  TButton *cmdDelete;
  TGroupBox *grpProperties;
  TLabel *lblCaption;
  TLabel *lblHeight;
  TLabel *lblModalResult;
  TLabel *lblWidth;
  TEdit *txtCaption;
  TEdit *txtWidth;
  TEdit *txtHeight;
  TCheckBox *chkDefault;
  TCheckBox *chkCancel;
  TCheckBox *chkHelp;
  TComboBox *cboModalResult;
  TButton *cmdHelp;
  TPopupMenu *mnuPopup;
  TMenuItem *mnuPopupOk;
  TMenuItem *mnuPopupCancel;
  TMenuItem *mnuPopupHelp;
  TMenuItem *N1;
  TMenuItem *mnuPopupYes;
  TMenuItem *mnuPopupNo;
  TMenuItem *N2;
  TMenuItem *mnuPopupAbort;
  TMenuItem *mnuPopupRetry;
  TMenuItem *mnuPopupIgnore;
  TMenuItem *mnuPopupDefault;
  TMenuItem *N3;
  TLabel *Label1;
  TMaskEdit *txtID;
  void __fastcall cmdDeleteClick(TObject *Sender);
  void __fastcall lstButtonsClick(TObject *Sender);
  void __fastcall txtCaptionChange(TObject *Sender);
  void __fastcall cmdOkClick(TObject *Sender);
  void __fastcall mnuPopupClick(TObject *Sender);
  void __fastcall cmdNewMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
  
private:
  TDcjButtons *FButtons;
  int iCurrentIndex;

protected:
  void __fastcall DisplayButtonProperties(TDcjButton *pButton);
  void __fastcall StoreProperties(TDcjButton *pButton);
  void __fastcall ClearButtonProperties(void);
public:
	virtual __fastcall TDcjButtonsEditDlg(TComponent* AOwner);
  virtual __fastcall ~TDcjButtonsEditDlg(void);

  void __fastcall DisplayButtons(void);
  __property TDcjButtons *Buttons = {read=FButtons, write=FButtons};
};
//----------------------------------------------------------------------------
// Component Editor Declarations
//----------------------------------------------------------------------------
class PACKAGE TDcjButtonsEditor : public TDefaultEditor
{
protected:
  // protected member functions
  void __fastcall EditButtons(void);
public:
	// constructor
  __fastcall virtual TDcjButtonsEditor(Classes::TComponent* AComponent,
  		TFormDesigner* ADesigner);

  // overridden public member functions
	virtual void __fastcall ExecuteVerb(int Index);
	virtual AnsiString __fastcall GetVerb(int Index);
	virtual int __fastcall GetVerbCount(void);
  virtual void __fastcall Edit(void);
};
//----------------------------------------------------------------------------
// Property Editor Declarations
//----------------------------------------------------------------------------
class PACKAGE TDcjButtonsProperty : public TPropertyEditor
{
public:
  __fastcall TDcjButtonsProperty(void);
  virtual __fastcall ~TDcjButtonsProperty(void);

  // overriden public member functions
  virtual void __fastcall Edit();
  virtual TPropertyAttributes __fastcall GetAttributes(void);
	virtual AnsiString __fastcall GetValue(void);
};
//----------------------------------------------------------------------------
extern PACKAGE TDcjButtonsEditDlg *DcjButtonsEditDlg;
//----------------------------------------------------------------------------
#endif
